"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var cheerio_1 = __importDefault(require("cheerio"));
var axios_1 = __importDefault(require("axios"));
var path_1 = __importDefault(require("path"));
var url_1 = require("url");
var gradesURL = function (courseURL) { return new url_1.URL(path_1.default.join(courseURL.href, "grades")); };
exports.grades = function (courseURL, login) { return __awaiter(_this, void 0, void 0, function () {
    var url, params, response, $, gradeTable, rows, dataRows;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                url = gradesURL(courseURL);
                params = {
                    user: login.name,
                    effectiveUser: login.name,
                    key: login.key
                };
                return [4 /*yield*/, axios_1.default.get(url.href, { params: params })];
            case 1:
                response = _a.sent();
                $ = cheerio_1.default.load(response.data);
                gradeTable = $("#grades_table");
                rows = gradeTable.find("tr").toArray();
                dataRows = rows.slice(2);
                return [2 /*return*/, {
                        assignments: dataRows.map(function (row) {
                            var _a = row.childNodes, name = _a[0].children[0].children[0].data, score = _a[2].children[0].data, possibleScore = _a[4].children[0].data, problems = _a.slice(6);
                            return {
                                name: name,
                                score: Number.parseFloat(score),
                                possibleScore: Number.parseFloat(possibleScore),
                                problems: problems
                                    .filter(function (x) { return x.type !== "text"; })
                                    .map(function (td) {
                                    var _a = td.childNodes, grade = _a[0].children[0].data, attempts = _a[2].data;
                                    return {
                                        grade: grade !== "C" ? Number.parseFloat(grade) : grade,
                                        attempts: Number.parseInt(attempts)
                                    };
                                })
                            };
                        })
                    }];
        }
    });
}); };
